/*
[LOWNOISE] WMAP v1.3 X-MAS adjustment version      
by Efrain 'ET' Torres
et@cyberspace.org 
   
Colombia DEC-2002
*/ 

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/stat.h>
#include <sys/socket.h>
/*#include <arpa/nameser.h>*/
#include <netinet/in.h>
#include <netdb.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <string.h>
#include <strings.h>
#include <signal.h>

#define MAX 10000 /* TAG MAX length , remember that any SCRIPT TAG can bypass MAX*/ 


/*DEFINE GLOBAL BEHAVIOR*/
int VERBOSE=0;			/* View status,verbose*/
int SUMMARY=0;		        /* View Summary of checked stuff*/

int NORECURSIVE=0;                /*NO Recursively */
int MAXLEVEL=10;                /*>=1*/
int SHOW_HOSTS_IN_DOMAIN=0;     /*for the analize_ref() "in" parameter */
int SHOW_USERS=0;               /*for the analize_ref() "users" parameter */
int DOMAIN=0;                   /*needed for SHOW* */

int NOCGISCAN=0;                 /*The user dont want a CGI scan*/
int NODIRSCAN=0;                 /*The user dont want a Interesting DIRs scan*/
int NOFILESCAN=0;                /*The user dont want a Interesting FILEs scan*/
int NOPUTSCAN=0;                 /*The user dont want a http PUT scan*/
int OTHERCGI=0;                  /*Show other cgis found in page*/

int SHOW=0;                      /*Show each test*/


/*I need to create a function to analize a big javascript tag, THIS IS THE BIG LIMITATION
OF WMAP . Javascript can produce weird results.*/


/*BASIC LIST NODE DEFINITION*/
struct node
{
            char linea[MAX];
            struct node *sig;
};
typedef struct node *lista;
typedef lista Lista;
typedef lista ptrLista;


void
usage(void);

void
about(void);

/*THE DO_ALL() FUNCTION :) */
void
funcion(struct hostent *he,char *host,int puerto,char *cadena,char *domain,int level,int maxlevel,Lista AlreadyDid);


/*ANALIZE THE TAG RECEIVED*/
char*
analize_tag(char *temp,char *cadena);

int
external_ref(char *temp,char *host,char *domain,int in,int users); /* view if tag reference is in the same host or outside and users*/

/*HREF TAG*/
char*
tag_href(char *temp);

/*FRAME TAG*/
char*
tag_frame(char *temp);

/*FORM TAG*/
char*
tag_form(char *temp,char *cadena);

/*THE BASIC LINKED LIST STUFF*/
ptrLista
Anterior(char *linea,Lista lst);

int
finLista(ptrLista Ptr,Lista lst);

Lista 
NuevaLista(void);

int
VaciaLista(Lista lst);
        
ptrLista
BuscarLista(char *linea, Lista lst);

void 
BorrarElemLista(char *linea, Lista lst );
        
void 
InsertarLista(char *linea, Lista lst, ptrLista Ptr);
        
void 
BorrarLista(Lista lst);
        
ptrLista
SigLista(ptrLista Ptr);

char*
infoLista(ptrLista Ptr);

void
imprimirLista(Lista lst);
/*==========================*/


/*THE TESTS*/
/*CGI SCANNER*/
int
cgi_scanner(struct hostent *he,char *host,int puerto,char *path,char *cgifile, char *dirscgi);

/*Search for interesting dirs*/
/*if its found a interesting dir then is added to the tests*/
int
dir_scanner(struct hostent *he,char *host,int puerto,char *path,char *dirfile, Lista list);

int
check_parent(struct hostent *he,char *host,int puerto,char *path);

/*Search for interesting files*/
int
file_scanner(struct hostent *he,char *host,int puerto,char *path,char *files);

/*http put scan*/
int
put_scanner(struct hostent *he,char *host,int puerto,char *path,char *filename);

int
browseable(struct hostent *he,char *host,int puerto,char *path);


/*================THE MAIN====================*/
int
main(int argc, char *argv[]){
   
    char host[60],
         path[60],
	 sport[6],
	 arg[60],
	 domain[60],
	 buffer[1024],
	 logf[30];
    
    char *ptr,
         *clean1;
    
    int port,i,j;
    struct hostent *he;
    
    FILE *nfile;
    
    Lista TEMPORAL;
    TEMPORAL = NuevaLista();
    
    fprintf(stdout,"[LoWNOISE] WMAP v1.3    X-Mas adjustment version\n");
    fprintf(stdout,"                         by ET et@cyberspace.org\n");
    fprintf(stdout,"------------------------------------------------\n");
    if(argc < 2){
       usage();
       exit(0);
    }
    
    /*The Options*/
    for(i=1;i<argc;i++){ if(argv[i][0] == '-') {
                 for(j=1;j<strlen(argv[i]);j++){
                         switch(argv[i][j]) 
                                {
                                 case 'h':
                                        usage();
					exit(0);
                                        break;
				 case 'a':
				        about();
                                        break;
				 case 'v':
				        VERBOSE=1;
					break;  
				 case 's':
                                        //VIEW SUMMARY OF CHECKED STUFF
                                        SUMMARY=1;
                                        break;
				 case 'n':
                                        //Show new hosts found in domain
                                        SHOW_HOSTS_IN_DOMAIN=1;
                                        break;
				 case 'u':
                                        //Show new users found in domain
                                        SHOW_USERS=1;
                                        break;	
				 
				 case 'd':
                                        //DOMAIN
                                        strcpy(domain,argv[i+1]);
					DOMAIN=1;
                                        break;
                                 case 'r':
                                        //Recursive
                                        NORECURSIVE=1;
                                        break;
				 case 'c':
                                        //The user dont want a cgi scan
                                        NOCGISCAN=1;
                                        break;
				 case 'i':
                                        //The user dont want a interesting dirs scan
                                        NODIRSCAN=1;
                                        break;
				 case 'f':
                                        //The user dont want a interesting files scan
                                        NOFILESCAN=1;
                                        break;
				 case 'p':
                                        //The user dont want a http put scan
                                        NOPUTSCAN=1;
                                        break;	
				 case 'o':
                                        //Show Others cgis found in pages
                                        OTHERCGI=1;
                                        break;
				 case 't':
                                        //Show each test
                                        SHOW=1;
                                        break;	
				 case 'l':
                                        //log to file
					bzero(logf,30);
					strcpy(logf,argv[i+1]);
					if(logf[0]=='-'){
					  fprintf(stdout,"[You forgot the filename (-l <filename>) ]\n");
					  exit(0);
					}  
					fprintf(stdout,"[Saving results in %s ...]\n",logf);
                                        
					
					if(freopen(logf,"w",stdout) == NULL){
	                                   fprintf(stdout,"[ freopen failed. ]\n");
	                                   exit(0);
                                        }
					fflush(stdout);
					fprintf(stdout,"-LOG: %s\n",logf); 
					fprintf(stdout,"[LoWNOISE] WMAP v1.3        \n");
                                        break;			
				 default:
				     usage();
				     fprintf(stdout,"ERROR: Option not found.\n");
				     
				     exit(0); 
                                 break;
                                }
                        }
                }
            }
    
    
    bzero(arg,60);
    strcpy(arg,argv[1]);
      
    if(strstr(argv[1],"://")!=NULL){
      ptr=strstr(arg,"://");
      strcpy(arg,ptr+3);
      
    }  
    
    /*the initial path*/
    bzero(path,60);
    if(strstr(arg,"/")==NULL ){
      strcpy(path,"/");
    }
    else{
       ptr=strstr(arg,"/");
       strcpy(path,ptr);
       *ptr='\0';
    }
    
    
    /*the port*/
    bzero(sport,6);
    if(strstr(arg,":")==NULL){
       port=80;
    }
    else{
       ptr=strstr(arg,":");
       strcpy(sport,ptr);
       port=atoi(sport+1);
       *ptr='\0';
    }
       
    
    /*the host*/
    bzero(host,60);
    strcpy(host,arg); 
    
    
    
    
    if(VERBOSE == 1){
      fprintf(stdout,"[Host: %s]\n",host);
      fprintf(stdout,"[Port: %d]\n",port);
      fprintf(stdout,"[Path: %s]\n",path);
      if(DOMAIN==1){
         fprintf(stdout,"[Domain: %s]\n",domain);
      }
    }
    
    
    /*Lets add here all that garbage paths*/
    /*ALL THE PATHS WE DONT WANT TO SCAN */
    /*FILE NOSCAN.DB*/
    /*Dont add the / path */
    InsertarLista("/./",TEMPORAL,TEMPORAL);
    InsertarLista("/../",TEMPORAL,TEMPORAL);
    if((nfile = fopen("./db/noscan.db","r")) == NULL){
	   fprintf(stdout,"[Couldnt Open file noscan.db ]\n");
	   exit(0);
    }   
    bzero(buffer,1024);
    while(fgets(buffer,1024,nfile)!= NULL){
       if(buffer[0]!='#'){
         if(strstr(buffer,"\n")!=NULL){
	   clean1=strstr(buffer,"\n");
	   *clean1='\0';
	 }
	 if(VERBOSE==1){
           fprintf(stdout,"[Adding NO SCAN path: %s ]\n",buffer);
         }
         InsertarLista(buffer,TEMPORAL,TEMPORAL);
         bzero(buffer,1024);
       }
    }
    fclose(nfile);
    
    /*Lets add here all the paths that we dont want to scan*/
    /*0*/
    
    if((SHOW_HOSTS_IN_DOMAIN==1 || SHOW_USERS==1) && DOMAIN==0){
      usage();
      fprintf(stdout,"ERROR: -d <domain> needed\n");
      
      exit(0);
    }
    
    if(NORECURSIVE==1){
      MAXLEVEL=1;
    }  
    
    if ((he=gethostbyname(host)) == NULL) { 
     	   herror("gethostbyname"); 
           exit(0);
    }
    
    funcion(he,host,port,path,domain,0,MAXLEVEL,TEMPORAL);
    
    if(SUMMARY==1){
      fprintf(stdout,"\n[SUMMARY OF CHECKED STUFF: ]\n");
      imprimirLista(TEMPORAL);
    }
    
    fprintf(stdout,"[THE COOL END]\n");
    BorrarLista(TEMPORAL);
  
  return 0;
}


void
usage(void){
       fprintf(stdout,"usage: wmap host [options]\n");
       fprintf(stdout,"   ex: wmap www.target.com/\n");
       fprintf(stdout,"       wmap www.target.com:8080/\n");
       fprintf(stdout,"       wmap www.target.com/initial-path/blah \n");
                   
       fprintf(stdout,"\nOptions:\n\n");
       fprintf(stdout," -h   Help\n");
       fprintf(stdout," -a   About\n");
       fprintf(stdout," -v   Verbose\n");
       fprintf(stdout," -r   NO Recursive\n");
       fprintf(stdout," -c   NO CGI Scanning\n");
       fprintf(stdout," -i   NO DIR Scanning\n");
       fprintf(stdout," -f   NO FILE Scanning\n");
       fprintf(stdout," -p   NO HTTP PUT Scanning\n");
       fprintf(stdout," -o   Show others CGIs found on pages\n");
       fprintf(stdout," -s   View Summary of checked stuff\n");
       fprintf(stdout," -n   Show hosts (-d <domain> needed)\n");
       fprintf(stdout," -u   Show users (-d <domain> needed)\n");
       fprintf(stdout," -d <domain>     (-n,-u  ex. target.com)\n");
       fprintf(stdout," -t   Show each test\n");
       fprintf(stdout," -l <file>       Log everything to file\n"); 
       fprintf(stdout,"\nFiles: db/\n\n");
       fprintf(stdout," cgis.db      CGIs to scan for\n");
       fprintf(stdout," dircgis.db   Dirs where the CGIs can be found\n");
       fprintf(stdout," dirs.db      Interesting Dirs\n");
       fprintf(stdout," file.db      Interesting Files\n");
       fprintf(stdout," noscan.db    Dont Scan in those paths\n");         
       fprintf(stdout,"\n"); 
       
       return;
}

void
about(void){
     
     fprintf(stdout,"\n");
     fprintf(stdout,"         - Less Stupid Web Scanner -\n");
     fprintf(stdout,"           by ET et@cyberspace.org\n");
     fprintf(stdout,"---------------------------------------------\n");
     fprintf(stdout,"[LoWNOISE]          Nothing Reserved (n) 2002 \n");
     
     exit(0);
}

void
funcion(struct hostent *he,char *host,int puerto,char *cadena,char *domain,int level,int maxlevel,Lista TEMPORAL){

int sock;
struct in_addr addr; 
struct sockaddr_in sin;

char buffer[2];
char request[MAX];
char temp[MAX];
char temp0[MAX];
char temp1[MAX];
unsigned long st;
char *token, *fix;

int fin,
    fintag,
    cont,
    cont1,
    cont2;
    
    
    
  
/*THE LIST*/
Lista Ref,
      ptrRef;
ptrLista Ptr;
        
	/*The maxlevel has been reached!!!!*/
	if(level>=maxlevel){
	  return;
	}
        
	
	/*Lets check invalid types to not analize, i know ugly code, wait ver.2 */
	
	if(strstr(cadena,".gif")!= NULL || strstr(cadena,".GIF") != NULL){
	  return;
	}
	if(strstr(cadena,".jpg")!= NULL || strstr(cadena,".JPG") != NULL){
	  return;
	} 
	if(strstr(cadena,".bmp")!= NULL || strstr(cadena,".BMP") != NULL){
	  return;
	}
	if(strstr(cadena,".tar")!= NULL || strstr(cadena,".TAR") != NULL){
	  return;
	}
	if(strstr(cadena,".gz")!= NULL || strstr(cadena,".GZ") != NULL){
	  return;
	}
	if(strstr(cadena,".tgz")!= NULL || strstr(cadena,".TGZ") != NULL){
	  return;
	}
	if(strstr(cadena,".zip")!= NULL || strstr(cadena,".ZIP") != NULL){
	  return;
	}
	if(strstr(cadena,".swf")!= NULL || strstr(cadena,".SWF") != NULL){
	  return;
	}
	if(strstr(cadena,".aux")!= NULL || strstr(cadena,".AUX") != NULL){
	  return;
	}
	if(strstr(cadena,".ps")!= NULL || strstr(cadena,".PS") != NULL){
	  return;
	}
	if(strstr(cadena,".pdf")!= NULL || strstr(cadena,".PDF") != NULL){
	  return;
	}
	if(strstr(cadena,".dvi")!= NULL || strstr(cadena,".DVI") != NULL){
	  return;
	}
	if(strstr(cadena,".tex")!= NULL || strstr(cadena,".TEX") != NULL){
	  return;
	}
	if(strstr(cadena,".avi")!= NULL || strstr(cadena,".AVI") != NULL){
	  return;
	}
	if(strstr(cadena,".mov")!= NULL || strstr(cadena,".MOV") != NULL){
	  return;
	}
	if(strstr(cadena,".mpg")!= NULL || strstr(cadena,".MPG") != NULL){
	  return;
	}
	if(strstr(cadena,".txt")!= NULL || strstr(cadena,".TXT") != NULL){
	  return;
	}
	if(strstr(cadena,".rm")!= NULL || strstr(cadena,".RM") != NULL){
	  return;
	}
	
	if(BuscarLista(cadena,TEMPORAL)!=NULL){
          /*this means you already work in that path*/
	  return;
	}
	else{
            InsertarLista(cadena,TEMPORAL,TEMPORAL);
	}
	
	Ref = NuevaLista();
	ptrRef=Ref;
	
	
	//fprintf(stdout,"-->\n");
	//imprimirLista(TEMPORAL);
	//fprintf(stdout,"---\n");
	
	/*THE TESTS*/
	
	/*tests only for directories*/
	if(cadena[strlen(cadena)-1]=='/' ){
	  
	  browseable(he,host,puerto,cadena);
	  
	  if(NOCGISCAN==0){
	    cgi_scanner(he,host,puerto,cadena,"./db/cgis.db","./db/dircgis.db");
	  }
	  
	  if(NODIRSCAN==0){
	    /*i add those dirs found to the search list*/
	    dir_scanner(he,host,puerto,cadena,"./db/dirs.db",Ref); 
	  }
	  
	  if(NOFILESCAN==0){
	    file_scanner(he,host,puerto,cadena,"./db/file.db");
	  }
	  
	  if(NOPUTSCAN==0){
	    put_scanner(he,host,puerto,cadena,"readme.txt");
	  }
	}
	/*=========*/
	
	
	
	
	

	
	bzero(request,MAX);
  	bzero(temp,MAX);
  
  
	strcpy(request,"GET "); 
  	strcat(request,cadena);
  	strcat(request," HTTP/1.0");
  	if(VERBOSE==1){
	  fprintf(stdout,"[Checking: %s ] \n",cadena);
	  //fprintf(stdout,"[%s]\n",request); 
	}
	strcat(request,"\nHost: ");
	strcat(request,host);
	
	strcat(request,"\n\n");
  
        /*fin cadena*/
  
  	
  	sock=socket(AF_INET,SOCK_STREAM,0);
  	bcopy(he->h_addr, (char *)&sin.sin_addr,he->h_length);
  	sin.sin_family=AF_INET; 
  	sin.sin_port=htons(puerto);
  	if (connect(sock,(struct sockaddr*)&sin,sizeof(sin))!=0){  
     		perror("connect");  
  	}
  	
	send (sock, request, strlen(request),0);
  	
	
	
	fin=0;
	while(fin == 0){

		
		
		
		
		bzero(buffer,2);
		if(recv(sock, buffer,1,0) <= 0){
		  return;
		}  
  		//fprintf(stdout,"%s",buffer);   /*PRINT WHAT YOU RECEIVE*/
          	
		
		
		/*GET TAG*/
		if(buffer[0]=='<'){
	          fintag=0;
		  cont=1;
		  bzero(temp,MAX);
		  temp[0]=buffer[0];
		  while(fintag==0){
		       
		       bzero(buffer,2);
		       recv(sock,buffer,1,0);
		       temp[cont]=buffer[0];
		       cont++;
		       if(buffer[0]=='>'){
		         fintag=1;
		       }
		       if(cont>MAX){
		         fintag=1;
			 bzero(temp,MAX);
			 strcpy(temp,"<none>");
		       } 
		       else{
		         temp[cont]='\0';
		       }	   
		  }
		  /*for debugin*/
		  //fprintf(stdout,"+ %s\n",temp);
		  
		
		  /*LETS ANALIZE THE TAG*/
		  /*THE END OF THE PAGE*/
		  if((strstr(temp,"</HTML")!=NULL) || (strstr(temp,"</html")!=NULL)){
		    //fprintf(stdout,"[End of page]\n");
		    fin=1;
		  }
		  else{
		    strcpy(temp1,analize_tag(temp,cadena));
		    if(strlen(temp1)>0){
		      //fprintf(stdout,"%s\n",temp1);  /*RESULT*/
		      
		      /*Time to insert in list*/
		      /*View if the ref is external to host so not to be included*/
		      if(external_ref(temp1,host,domain,SHOW_HOSTS_IN_DOMAIN,SHOW_USERS)==0){ /*FIX REFERENCES 1 1*/
		               
			    
			    /*Add the initial path if isnt there but only to paths that are dirs*/
			    /* and temp1 isnt a initial path reference*/
			  
			    
			    if(temp1[0] != '/'){ /*this means that is a realtive path
			    	    
			    /* so we have to add the initial path*/
			      if(cadena[strlen(cadena)-1] != '/'){
			        cont=strlen(cadena)-1;
				while(cont >= 0){
				 if(cadena[cont]=='/'){
				   cadena[cont+1]='\0';
				   cont=0; 
				 }
			        cont--; 
				}
			      }
			      
			        bzero(temp0,MAX);
			        strcpy(temp0,cadena);
			        strcat(temp0,temp1);
			        bzero(temp1,MAX);
			        strcpy(temp1,temp0);
			      	
			    }
			    
			    /*lets erase all  the /./ paths - ugly "machetazo" (quickfix) */
			    bzero(temp,MAX);
			    bzero(temp0,MAX);
			    strcpy(temp,temp1);
			    strcpy(temp0,temp1);
			    while(strstr(temp0,"/./") != NULL){ 
			        fix=strstr(temp,"/./");
				*fix='\0';
				fix=strstr(temp0,"/./");
				strcat(temp,fix+2);
				bzero(temp0,MAX);
				strcpy(temp0,temp);
				
			    
			    }
			    bzero(temp1,MAX);
			    strcpy(temp1,temp0);
			    
			    /*lets erase all  the / / paths - ugly "machetazo n.2" (quickfix) */
			    bzero(temp,MAX);
			    bzero(temp0,MAX);
			    strcpy(temp,temp1);
			    strcpy(temp0,temp1);
			    while(strstr(temp0,"/ /") != NULL){ 
			        fix=strstr(temp,"/ /");
				*fix='\0';
				fix=strstr(temp0,"/ /");
				strcat(temp,fix+2);
				bzero(temp0,MAX);
				strcpy(temp0,temp);
				
			    
			    }
			    bzero(temp1,MAX);
			    strcpy(temp1,temp0);
			    
			    
			    
			    
			    
			    /*KILLING SOME BAD STUFF*/
			    fix=strstr(temp1,"/?");
			    if(fix != NULL){
			      fix++;
			      *fix='\0'; 
			    }
			    
			    fix=strstr(temp1,"?");
			    if(fix != NULL){
			      if(NOCGISCAN==0 && OTHERCGI==1){
			        fprintf(stdout,"--[ CGI Found: %s ]\n",temp1);
			      }
			      *fix='\0'; 
			    }
			    
			    fix=strstr(temp1,".pl\0");
			    if(fix != NULL){
			      if(NOCGISCAN==0 && OTHERCGI==1){
			        fprintf(stdout,"--[ CGI Found: %s ]\n",temp1);
			      } 
			    }
			    
			    fix=strstr(temp1,".cgi\0");
			    if(fix != NULL){
			      if(NOCGISCAN==0 && OTHERCGI==1){
			        fprintf(stdout,"--[ CGI Found: %s ]\n",temp1);
			      } 
			    }
			    
			    fix=strstr(temp1,".sh\0");
			    if(fix != NULL && (strstr(temp1,".shtm")==NULL)){
			      if(NOCGISCAN==0 && OTHERCGI==1){
			        fprintf(stdout,"--[ CGI Found: %s ]\n",temp1);
			      } 
			    }
			    
			    fix=strstr(temp1,".exe\0");
			    if(fix != NULL){
			      if(NOCGISCAN==0 && OTHERCGI==1){
			        fprintf(stdout,"--[ CGI Found: %s ]\n",temp1);
			      }
			    }
			    
			    /*lets check if the ref begins with "/" */
			    bzero(temp,MAX);
			    if(temp1[0] != '/' ){
			       strcpy(temp,"/");
			       strcat(temp,temp1);
			       bzero(temp1,MAX);
			       strcpy(temp1,temp);
			    }
			    if(strstr(temp1,"../")!=NULL){
			      strcpy(temp,strstr(temp1,"../"));
			      strcpy(temp1,strstr(temp,"/"));
			    }
			    
			    /*before insert lets check that it isnt already there in the list*/
			    if(BuscarLista(temp1,Ref)==NULL){
			      InsertarLista(temp1,Ref,ptrRef);
		              ptrRef=SigLista(ptrRef);
			    
			      /*If the reference has multiple dirs it has to be divided and inserted*/
			      cont1=0;
			      cont2=0;
			      while(cont1 < strlen(temp1)){
			       if(temp1[cont1]=='/'){
			          cont2++;
			       }   
			       cont1++;
			      }
			    
			     cont1=1;
			     token=temp1+strlen(temp1)-1;
			     while(cont1 < cont2){
			      if(token[0]=='/'){
			       token[0]='\0';
			       strcat(temp1,"/");
			       //fprintf(stdout,"+ %s %d\n",temp1,cont2);
			       
			       /* again before insert lets check that it isnt already there in the list*/
			       if(BuscarLista(temp1,Ref)==NULL){
			         /*Insert now*/
			         InsertarLista(temp1,Ref,ptrRef);
		                 ptrRef=SigLista(ptrRef);
			         /*----------*/
			       }
			       cont1++;
			      }  
			      token--; 
			     }
			     /*end of dir mutilation - ugly code*/
		      }	    
		      }	
		    }  
		  }
		  
		}
	}
	close(sock);
	
	/* for debug purpose*/
	//imprimirLista(Ref);
	
	
	
	/*================ THE RECURSIVE S*** PART ===================*/
	Ptr = Ref;

        if(VaciaLista(Ref)){
           return;
        }	
        else{
           do{
            Ptr=SigLista(Ptr);
            funcion(he,host,puerto,infoLista(Ptr),domain,level+1,maxlevel,TEMPORAL);
	    
           } while(!finLista(Ptr,Ref ) );
        
       }
       /*============================================================*/
       BorrarLista(Ref);
       return;

	
  	


}	



/*TIME TO ANALIZE TAG*/
char*
analize_tag(char *temp,char *cadena){

static char temp1[MAX];
char *ptrtag1;
char *clean; 
		    /*convert all to " */
		    
                    while(strstr(temp,"'")!=NULL){
		       clean=strstr(temp,"'");
		       *clean='\"'; 
                    
		    }      
  
		    bzero(temp1,MAX);
		    /*HREF LINK TAG*/
		    if(((ptrtag1=strstr(temp,"HREF="))!=NULL) || ((ptrtag1=strstr(temp,"href="))!=NULL)){
		       
		       strcpy(temp1,tag_href(temp));
		       return temp1;
		       
             	    }   
		    /*END HREF LINK TAG*/
		    
		    /*FRAME TAG*/
		    if((strstr(temp,"<FRAME ")!=NULL) || (strstr(temp,"<frame ")!=NULL)){
		       strcpy(temp1,tag_frame(temp));
		       return temp1; 
		    }
		    /*END FRAME TAG*/
		    
		    /*FORM TAG*/
		    if((strstr(temp,"<FORM ")!=NULL) || (strstr(temp,"<form ")!=NULL)){
		       strcpy(temp1,tag_form(temp,cadena));
		       return temp1; 
		    }
		    /*END FORM TAG*/

return temp1;
}

/*ANALIZE IF TAG REFERENCE IS EXTERNAL OR IS IN THE SAME HOST*/
int
external_ref(char *temp,char *host,char *domain, int in,int users){
	
	char *ptrtag,
	     *ptrtag1,
	     *ptrtemp,
	     *ptrtemp1;
	
	
	if(temp[0]=='/' || temp[0]=='.'){
	   return 0;
	}   
	
	/*IF in == 1 THEN ALL THE HOSTS THAT APPEARS IN THE SAME DOMAIN ARE SHOWED*/
	/*maybe is a new host*/
	if((ptrtag=strstr(temp,"http://"))!=NULL || (ptrtag=strstr(temp,"ftp://"))!= NULL || (ptrtag=strstr(temp,"telnet://"))!= NULL ){
	   
	   if((in==1) &&(strstr(temp,domain)!=NULL) && (strstr(temp,host)==NULL)){
	     /*Found a host that it isnt the same HOST :)*/
	     	
	     ptrtemp=strstr(temp,"://");
	     ptrtemp=ptrtemp+3;
	     
	     ptrtemp1=strstr(temp,domain);
	     if(ptrtemp1[strlen(domain)] != '\0'){
	        ptrtemp1[strlen(domain)]='\0';
	     }	
	     fprintf(stdout,"-[Host Found: %s]\n",ptrtemp);
	   }
	   return 1;

	}
	if((ptrtag=strstr(temp,"mailto:"))!=NULL  && users ==1 ){
	   if(strstr(temp,domain)!=NULL){
	  	   ptrtemp=strstr(temp,"mailto:");
	           ptrtemp=ptrtemp+7;
		   fprintf(stdout,"-[User Found: %s]\n",ptrtemp);
	           
	   }
	   return 1;	   
	}
	if(strstr(temp,"://")!=NULL){
	   return 1;
	}
	return 0;   
	   

}


/*HREF TAG*/
char*
tag_href(char *temp){
       
    char *ptrtag2,
         *ptrtag1,
         *ptrtag;   
     
    static char temp1[MAX];
    
       
       		if(((ptrtag1=strstr(temp,"HREF"))!=NULL) || ((ptrtag1=strstr(temp,"href"))!=NULL)){
         	       ptrtag=strstr(ptrtag1,"=");
		       if(ptrtag == NULL){
		         
			   fprintf(stdout,"[Bad coded tag: %s]\n",temp);
		         
		       }
		       else{
		         
		         ptrtag++;
		         if(*ptrtag=='\"'){
			   
			   bzero(temp1,MAX);
			   strcpy(temp1,ptrtag+1);
			   ptrtag1=strstr(temp1,"\"");
		           if(ptrtag1== NULL  ){
			       fprintf(stdout,"[Bad coded tag: %s]\n",temp);
			   }
			   else{
			     *ptrtag1='\0';
		             
			   }
			   
			 }
			 else{
			   
			   bzero(temp1,MAX);
			   strcpy(temp1,ptrtag);
			   ptrtag1=strstr(temp1,">");
			   if(ptrtag1== NULL){
			       fprintf(stdout,"[Bad coded tag: %s]\n",temp);
			   }
			   else{
			     *ptrtag1='\0';
		           }
			   
			 }
			 //fprintf(stdout,"HREF link: %s\n",temp1);
			 
			 
			 if ((ptrtag1 = strstr(temp1,"#"))!=NULL){
			   bzero(temp1,MAX);
			   strcpy(temp1,"");
			 
			 }
			  
			 
			
			 return temp1;  
		       }  
		}
		else{
		    return NULL;
		}			 
}


/*FRAME TAG*/
char*
tag_frame(char *temp){

char *ptrtag1,
     *ptrtag;   
     
static char temp1[MAX];	

	if((strstr(temp,"FRAME ")!=NULL) || (strstr(temp,"frame ")!=NULL)){
		       ptrtag=strstr(temp,"SRC");
		       if(ptrtag == NULL){
		          ptrtag=strstr(temp,"src");
		       }  
		       if(ptrtag == NULL){
		           fprintf(stdout,"[Bad coded tag: %s]\n",temp);
		       }  
		       else{
		         
		         ptrtag=ptrtag+4;
		         if(*ptrtag=='\"'){
			   bzero(temp1,MAX);
			   strcpy(temp1,ptrtag+1);
			   ptrtag1=strstr(temp1,"\"");
		           if(ptrtag1== NULL ){
			       fprintf(stdout,"[Bad coded tag: %s]\n",temp);
			   }
			   else{
			     *ptrtag1='\0';
		             
			   }
			 }
			 else{
			   bzero(temp1,MAX);
			   strcpy(temp1,ptrtag);
			   ptrtag1=strstr(temp1,">");
			   if(ptrtag1== NULL ){
			       fprintf(stdout,"[Bad coded tag: %s]\n",temp);
			   }
			   else{
			     *ptrtag1='\0';
		           }
			 }
			 //fprintf(stdout,"FRAME Src: %s\n",temp1);
			 return temp1;  
		       }  
	}
	else{
	     return NULL;
	}     

}

/*FORM TAG*/
char*
tag_form(char *temp,char *cadena){
       
    char *ptrtag2,
         *ptrtag1,
         *ptrtag;   
     
    static char temp1[MAX];
    char temp2[MAX],
	 temp3[MAX];
    
       
       		if(((ptrtag1=strstr(temp,"FORM"))!=NULL) || ((ptrtag1=strstr(temp,"form"))!=NULL)){
         	       
		       bzero(temp2,MAX);
		       bzero(temp3,MAX);
		       
		       strcpy(temp2,temp);
		       ptrtag=strstr(temp2,"method=");
		       if(ptrtag == NULL){
		         ptrtag=strstr(temp2,"METHOD=");
		       }
		       if(ptrtag == NULL){
		         strcpy(temp3,"GET");
		       }
		       else{
		         
		         ptrtag=ptrtag+7;
		         if(*ptrtag=='\"'){
			   
			   bzero(temp3,MAX);
			   strcpy(temp3,ptrtag+1);
			   ptrtag=strstr(temp3,"\"");
		           if(ptrtag1== NULL ){
			       fprintf(stdout,"[ Bad coded tag: %s]\n",temp);
			   }
			   else{
			     *ptrtag='\0';
		             
			   }
			   
			  }
			
		       }
		       
		       
		       
		       
		       
		       
		       ptrtag=strstr(ptrtag1,"action=");
		       if(ptrtag == NULL){
		         ptrtag=strstr(ptrtag1,"ACTION=");
		       }
		       if(ptrtag == NULL){
		         if(VERBOSE==1){
			   fprintf(stdout,"-[No form action info]\n");
			 }
			 bzero(temp1,MAX);
			 strcpy(temp1,"/./");
			 
			 return temp1;
		       }
		       else{
		         
		         ptrtag=ptrtag+7;
		         if(*ptrtag=='\"'){
			   
			   bzero(temp1,MAX);
			   strcpy(temp1,ptrtag+1);
			   ptrtag1=strstr(temp1,"\"");
		           if(ptrtag1== NULL ){
			       fprintf(stdout,"[Bad coded tag: %s]\n",temp);
			   }
			   else{
			     *ptrtag1='\0';
		             
			   }
			   
			 }
			 else{
			   
			   bzero(temp1,MAX);
			   strcpy(temp1,ptrtag);
			   ptrtag1=strstr(temp1,">");
			   if(ptrtag1== NULL ){
			       fprintf(stdout,"[Bad coded tag: %s]\n",temp);
			   }
			   else{
			     *ptrtag1='\0';
		           }
			   
			 }
			 
			 if(OTHERCGI==1){
			   fprintf(stdout,"--[FORM CGI Found: %s ]\n",temp1);
			   fprintf(stdout,"--- Referenced by: %s \n",cadena);
			   fprintf(stdout,"---------- Method: %s \n",temp3);
			 }
			 
			 if ((ptrtag1 = strstr(temp1,"#"))!=NULL){
			   bzero(temp1,MAX);
			   strcpy(temp1,"");
			 
			 }
			  
			 
			
			 return temp1;  
		       }  
		}
		else{
		    return NULL;
		}			 
}


/*THE BASIC LINKED LIST STUFF - REMEMBER OLD TIMES :) */
/*Ripped and twisted from i dont remember             */
/*Too lazzy to build a new one                        */

ptrLista
Anterior(char *linea,Lista lst){

	ptrLista Ptr;

	Ptr = lst;
	while( Ptr->sig != NULL && strcmp(Ptr->sig->linea,linea) != 0 )
	Ptr = Ptr->sig;

	return Ptr;
}

int
finLista(ptrLista Ptr,Lista lst){
     if((Ptr->sig) == NULL)
        return 1;
     return 0;
}


Lista 
NuevaLista(void){
     Lista lst;
     
     if((lst = malloc(sizeof( struct node)))==NULL){
         fprintf(stdout,"[Newlist error no mem.]\n");
	 exit(0);
     }	 
     else{ 
         lst->sig = NULL;
         return lst;
     }
}

int
VaciaLista(Lista lst){
     if((lst->sig) == NULL)
        return 1;
     return 0;	     	
}
        
ptrLista
BuscarLista(char *linea, Lista lst){

	ptrLista Ptr;

	Ptr = lst->sig;
	while(Ptr != NULL && strcmp(Ptr->linea,linea)!=0){
             Ptr = Ptr->sig;
        }
        return Ptr;
}

void 
BorrarElemLista(char *linea, Lista lst ){

            ptrLista Ptr, tmp;

            Ptr = Anterior( linea, lst );

            if( !finLista( Ptr, lst ) )  
            {                      
                tmp = Ptr->sig;
                Ptr->sig = tmp->sig;  
                free(tmp);
            }

}
        
void 
InsertarLista(char *linea, Lista lst, ptrLista Ptr){
	ptrLista tmp;

	tmp = malloc(sizeof(struct node));
	if(tmp==NULL){
	       fprintf(stdout,"Error no Mem ListInsert.\n");
	       exit(0);	
	}       
	strcpy(tmp->linea,linea);
      	tmp->sig = Ptr->sig;
      	Ptr->sig = tmp;		
}
        
void 
BorrarLista(Lista lst){
	ptrLista Ptr, 
		 tmp;

    	Ptr = lst->sig;  
    	lst->sig = NULL;
    	while(Ptr!= NULL){
           tmp = Ptr->sig;
	   free(Ptr);
	   Ptr=tmp;
        }
}
        
ptrLista
SigLista(ptrLista Ptr){
     return Ptr->sig;
}

char*
infoLista(ptrLista Ptr){
    return Ptr->linea;
}

void
imprimirLista(Lista lst){
    ptrLista Ptr;
    
    fprintf(stdout,"[List: ]\n");
    Ptr = lst;

    if(VaciaLista(lst)){
        fprintf(stdout,"[Empty List]\n");
    }	
    else{
        do
        {
            Ptr=SigLista(Ptr);
            fprintf(stdout, "-[ %s ]\n",infoLista(Ptr));
        } while(!finLista(Ptr,lst ) );
        
    }
}

/*==========================*/

/*THE TESTS*/
/*CGI SCANNER*/
int
cgi_scanner(struct hostent *he,char *host,int puerto,char *path,char *cgifile, char *dirscgi){

	
	FILE *fcgi;
	FILE *fdir;
	
	char buffer[1024],
	     buffer1[1024],
	     request[1024],
	     recbuffer[512];
	     
	char *cleannl;     
	
	int sock;
	struct in_addr addr; 
	struct sockaddr_in sin;
	
	
	
	char cgifound1[] = "200 ";  /*Found Code*/
	
	
	
	if(VERBOSE==1){
	  fprintf(stdout,"\n[Scanning CGIs on http://%s:%d%s ]\n",host,puerto,path);
	}
	//fprintf(stdout,"-[Opening CGI file: %s ]\n",cgifile);
	if((fcgi = fopen(cgifile,"r")) == NULL){
	   fprintf(stdout,"[Couldnt Open file %s ]\n",cgifile);
	   exit(0);
	}   
	bzero(buffer,1024);
	bzero(request,1024);
	if(VERBOSE==1){
	  fprintf(stdout,"-[Testing... ]\n");
	}
	while(fgets(buffer,1024,fcgi)!= NULL){
	  /*if it isnt a comment*/
	  if(buffer[0] != '#' && buffer[1] != '#'){  
	   
	     //fprintf(stdout,"[Connecting...]\n");
	     
	     
  	     sock=socket(AF_INET,SOCK_STREAM,0);
  	     bcopy(he->h_addr, (char *)&sin.sin_addr,he->h_length);
  	     sin.sin_family=AF_INET; 
  	     sin.sin_port=htons(puerto);
  	     if (connect(sock,(struct sockaddr*)&sin,sizeof(sin))!=0){  
      		 perror("[Error: connect]\n");
		
		 exit(0);  
  	     }
  	     
	     /*cleaning the new line char*/
	     if((cleannl=strstr(buffer,"\n"))!=NULL){
	       *cleannl='\0';
	     
	     }
	     if(SHOW==1){
	       fprintf(stdout,"-[CGI: %s%s ]\n",path,buffer);
	     }
	     strcpy(request,"GET ");
	     strcat(request,path);
	     strcat(request,buffer);
	     strcat(request," HTTP/1.0");
	     strcat(request,"\nHost: ");
	     strcat(request,host);
	     strcat(request,"\n\n");
	     //fprintf(stdout,"%s",request); /*for debug purpose*/
	     
	     send (sock, request, strlen(request),0);
	     bzero(recbuffer,512);
	     recv(sock, recbuffer,sizeof(recbuffer),0);
             //fprintf(stdout,"rcv: %s\n",recbuffer); /*for debug purpose*/ 

             if(strstr(recbuffer,cgifound1)!=NULL){
	       	       fprintf(stdout,"--[ CGI Found!!!: %s%s ]\n",path,buffer);
	      
	     }
        		
	   bzero(request,1024);
           close(sock);
	   
	   /*Looking in those common cgi dirs using the path path+dir+cgi*/
	   /*buffer contains the cgi*/
           //fprintf(stdout,"-[Opening CGIs DIRs file: %s ]\n",dirscgi);
	   if((fdir = fopen(dirscgi,"r")) == NULL){
	     fprintf(stdout,"[Couldnt Open CGIs DIR file %s ]\n",dirscgi);
	     exit(0);
	   }
	   bzero(buffer1,1024);
	   
	   while(fgets(buffer1,1024,fdir)!= NULL){
	    /*if it isnt a comment*/
	    if(buffer1[0] != '#' && buffer1[1] != '#'){
	  
	     //fprintf(stdout,"[Connecting...]\n");
	      
  	     sock=socket(AF_INET,SOCK_STREAM,0);
  	     bcopy(he->h_addr, (char *)&sin.sin_addr,he->h_length);
  	     sin.sin_family=AF_INET; 
  	     sin.sin_port=htons(puerto);
  	     if (connect(sock,(struct sockaddr*)&sin,sizeof(sin))!=0){  
      		 perror("[Error: connect]\n");
		 exit(0);  
  	     }
  	     
	     /*cleaning the new line char*/
	     if((cleannl=strstr(buffer1,"\n"))!=NULL){
	       *cleannl='\0';
	     }
	     if(SHOW==1){
	       fprintf(stdout,"-[CGI: %s%s%s ]\n",path,buffer1,buffer);
	     }
	     strcpy(request,"GET ");
	     strcat(request,path);
	     strcat(request,buffer1);
	     strcat(request,buffer);
	     strcat(request," HTTP/1.0");
	     strcat(request,"\nHost: ");
	     strcat(request,host);
	     strcat(request,"\n\n");
	     //fprintf(stdout,"%s",request); /*for debug purpose*/
	     
	     send (sock, request, strlen(request),0);
	     bzero(recbuffer,512);
	     recv(sock, recbuffer,sizeof(recbuffer),0);
             
             if(strstr(recbuffer,cgifound1)!=NULL){
	         fprintf(stdout,"--[ CGI Found!!!: %s%s%s ]\n",path,buffer1,buffer);
	        
	     }
             close(sock);		
	     bzero(request,1024);
	     bzero(buffer1,1024);
	    }
	   }
	   
	   fclose(fdir);
	   bzero(buffer,1024);
	  }
	}
	if(VERBOSE==1){
	  fprintf(stdout,"[End of CGI Scanning in %s ]\n",path);
	}
	close(sock);
	fclose(fcgi);

	return 0; 

}


/*DIR SCANNER - its very very similar (equal) to the cgi scanner but is just to separate things*/
/*and easier to add things*/

int
dir_scanner(struct hostent *he,char *host,int puerto,char *path,char *dirfile,Lista list){

	
	FILE *fdir;
	char buffer[1024],
	     request[1024],
	     recbuffer[512],
	     temp[1024];
	     
	char *cleannl;     
	
	int sock;
	struct in_addr addr; 
	struct sockaddr_in sin;
	
	
	
	char dirfound1[] = "200 ";  /*Found Code*/
	char dirfound2[] = "403 ";  /*Found Code, Exist but cant be accessed (directly) */
	char dirfound3[] = "401 ";  /*Found Code, Authentication required*/
	
	
	if(VERBOSE==1){
	  fprintf(stdout,"\n[Searching for Interesting DIRs on http://%s:%d%s ]\n",host,puerto,path);
	  //fprintf(stdout,"-[Opening DIR file: %s ]\n",dirfile);
	}
	
	if((fdir = fopen(dirfile,"r")) == NULL){
	   fprintf(stdout,"[Couldnt Open file %s ]\n",dirfile);
	   exit(0);
	}   
	bzero(buffer,1024);
	bzero(request,1024);
	if(VERBOSE==1){
	  fprintf(stdout,"-[Testing... ]\n");
	}
	while(fgets(buffer,1024,fdir)!= NULL){
	  /*if it isnt a comment*/
	  if(buffer[0] != '#' && buffer[1] != '#'){   
	     //fprintf(stdout,"[Connecting...]\n");
	     
	      
  	     sock=socket(AF_INET,SOCK_STREAM,0);
  	     bcopy(he->h_addr, (char *)&sin.sin_addr,he->h_length);
  	     sin.sin_family=AF_INET; 
  	     sin.sin_port=htons(puerto);
  	     if (connect(sock,(struct sockaddr*)&sin,sizeof(sin))!=0){  
      		 perror("[Error: connect]\n");
		 exit(0);  
  	     }
  	     
	     /*cleaning the new line char*/
	     if((cleannl=strstr(buffer,"\n"))!=NULL){
	       *cleannl='\0';
	     
	     }
	     if(SHOW==1){
	      fprintf(stdout,"-[DIR: %s%s ]\n",path,buffer);
	     }
	     strcpy(request,"GET ");
	     
	     strcat(request,path);
	     strcat(request,buffer);
	     if(buffer[strlen(buffer)]!='/'){
	       strcat(request,"/"); 
	     }
	     strcat(request," HTTP/1.0");
	     strcat(request,"\nHost: ");
	     strcat(request,host);
	     strcat(request,"\n\n");
	     //fprintf(stdout,"%s",request); /*for debug purpose*/
	     
	     send (sock, request, strlen(request),0);
	     
	     bzero(recbuffer,512);
	     recv(sock, recbuffer,sizeof(recbuffer),0);
             //fprintf(stdout,"rcv: %s\n",recbuffer); /*for debug purpose*/ 

             if(strstr(recbuffer,dirfound1)!=NULL){ 
	       fprintf(stdout,"--[ DIR Found!!!: %s%s ]\n",path,buffer);
               
	       /*lets insert the dir found to the tests*/
	       bzero(temp,1024);
	       strcpy(temp,path);
	       strcat(temp,buffer);
	       InsertarLista(temp,list,list);
	       if(strstr(recbuffer,"Index of ")!=NULL){
	         fprintf(stdout,"--[ BROWSEABLE %s%s ]\n",path,buffer);
	       }
	       
	     }
             else if(strstr(recbuffer,dirfound2)!=NULL){ 
	       //fprintf(stdout,"--[ DIR Found - Access Forbidden ( %s): %s%s ]\n",dirfound2,path,buffer);
	       if(check_parent(he,host,puerto,path)==0){
	       fprintf(stdout,"--[ DIR Found - Access Forbidden ( %s): %s%s ]\n",dirfound2,path,buffer);
	       
	       /*lets insert the dir found to the tests*/
	       bzero(temp,1024);
	       strcpy(temp,path);
	       strcat(temp,buffer);
	       InsertarLista(temp,list,list);
	       }
	       else{
	          //*printf("parent closed\n");
	       }	  
	     
	     }
	     else if(strstr(recbuffer,dirfound3)!=NULL){ 
	       fprintf(stdout,"--[ DIR Found - Authentication needed  ( %s): %s%s ]\n",dirfound3,path,buffer);
	       /* here we need authentication */
	     }    		
	
	  close(sock);
	  bzero(request,1024);
          bzero(buffer,1024);
	  }
        }
	if(VERBOSE==1){
	  fprintf(stdout,"[END of DIRs Search in %s ]\n\n",path);
	}
	close(sock);
	fclose(fdir);
	return 0; 

}

int
check_parent(struct hostent *he,char *host,int puerto,char *path){

	
	FILE *fdir;
	char buffer[1024],
	     request[1024],
	     recbuffer[512],
	     temp[1024];
	     
	char *cleannl;     
	
	int sock,r;
	struct in_addr addr; 
	struct sockaddr_in sin;
	
	
	
	char dirfound1[] = "200 ";  /*Found Code*/
	char dirfound2[] = "403 ";  /*Found Code, Exist but cant be accessed (directly) */
	char dirfound3[] = "401 ";  /*Found Code, Authentication required*/
	
	
	if(VERBOSE==1){
	  //fprintf(stdout,"\n[Checking the parent on http://%s:%d%s ]\n",host,puerto,path);
	 
	}
	
	   
	bzero(buffer,1024);
	bzero(request,1024);
	if(VERBOSE==1){
	  //fprintf(stdout,"-[Checking... ]\n");
	}
	     
	      
  	     sock=socket(AF_INET,SOCK_STREAM,0);
  	     bcopy(he->h_addr, (char *)&sin.sin_addr,he->h_length);
  	     sin.sin_family=AF_INET; 
  	     sin.sin_port=htons(puerto);
  	     if (connect(sock,(struct sockaddr*)&sin,sizeof(sin))!=0){  
      		 perror("[Error: connect]\n");
		 exit(0);  
  	     }
  	     
	     strcpy(request,"GET ");
	     
	     
	     r=strlen(buffer);
	     while(r>5 &&  buffer[r-1]!='/'){
	          r--; 
	     }
	     buffer[r]='\0';
	     
	     strcat(request,path);
	     strcat(request,buffer);
	     
	     strcat(request," HTTP/1.0");
	     strcat(request,"\nHost: ");
	     strcat(request,host);
	     strcat(request,"\n\n");
	     //fprintf(stdout,"Parent %s",request); /*for debug purpose*/
	     
	     send (sock, request, strlen(request),0);
	     
	     bzero(recbuffer,512);
	     recv(sock, recbuffer,sizeof(recbuffer),0);
             //fprintf(stdout,"rcv: %s\n",recbuffer); /*for debug purpose*/ 

             if(strstr(recbuffer,dirfound2)!=NULL){ 
	       return 1;
	     
	     }
	     else if(strstr(recbuffer,dirfound3)!=NULL){ 
	       return 1;
	     }    		
	
	  close(sock);
	  bzero(request,1024);
          bzero(buffer,1024);

	return 0; 

}






/*FILE SCANNER - AGAIN its very very similar (equal) to the dir scanner but is just to separate things
too */


int
file_scanner(struct hostent *he,char *host,int puerto,char *path,char *files){

	
	FILE *ffile;
	char buffer[1024],
	     request[1024],
	     recbuffer[512];
	     
	char *cleannl;     
	
	int sock;
	struct in_addr addr; 
	struct sockaddr_in sin;
	
	
	
	char filefound1[] = "200 ";  /*Found Code*/
	char filefound2[] = "403 ";  /*Found Code, Exist but cant be accessed (directly) */
	char filefound3[] = "401 ";  /*Found Code, Authentication required*/
	
	
	if(VERBOSE==1){
	  fprintf(stdout,"\n[Searching for Interesting FILES on http://%s:%d%s ]\n",host,puerto,path);
	  //fprintf(stdout,"-[Opening db file: %s ]\n",files);
	}
	if((ffile = fopen(files,"r")) == NULL){
	   fprintf(stdout,"[Couldnt Open file %s ]\n",files);
	   exit(0);
	}   
	bzero(buffer,1024);
	bzero(request,1024);
	if(VERBOSE==1){
	  fprintf(stdout,"-[Testing... ]\n");
	}
	while(fgets(buffer,1024,ffile)!= NULL){
	  /*if it isnt a comment*/
	  if(buffer[0] != '#' && buffer[1] != '#'){   
	     //fprintf(stdout,"[Connecting...]\n");
	     
	      
  	     sock=socket(AF_INET,SOCK_STREAM,0);
  	     bcopy(he->h_addr, (char *)&sin.sin_addr,he->h_length);
  	     sin.sin_family=AF_INET; 
  	     sin.sin_port=htons(puerto);
  	     if (connect(sock,(struct sockaddr*)&sin,sizeof(sin))!=0){  
      		 perror("[Error: connect]\n");
		 exit(0);  
  	     }
  	     
	     /*cleaning the new line char*/
	     if((cleannl=strstr(buffer,"\n"))!=NULL){
	       *cleannl='\0';
	     
	     }
	     if(SHOW==1){
	       fprintf(stdout,"-[FILE: %s%s ]\n",path,buffer);
	     }
	     strcpy(request,"GET ");
	     
	     strcat(request,path);
	     strcat(request,buffer);
	     strcat(request," HTTP/1.0");
	     strcat(request,"\nHost: ");
	     strcat(request,host);
	     strcat(request,"\n\n");
	     //fprintf(stdout,"%s",request); /*for debug purpose*/
	     
	     send (sock, request, strlen(request),0);
	     
	     bzero(recbuffer,512);
	     recv(sock, recbuffer,sizeof(recbuffer),0);
             //fprintf(stdout,"rcv: %s\n",recbuffer); /*for debug purpose*/ 

             if(strstr(recbuffer,filefound1)!=NULL){ 
	       fprintf(stdout,"--[ FILE Found!!!: %s%s ]\n",path,buffer);
	     }
             /*else if(strstr(recbuffer,filefound2)!=NULL){ 
	       fprintf(stdout,"--[ FILE Found ( %s): %s%s ]\n",filefound2,path,buffer);
	       
	     }*/
	     else if(strstr(recbuffer,filefound3)!=NULL){ 
	       fprintf(stdout,"--[ FILE Found - Authentication required ( %s): %s%s ]\n",filefound3,path,buffer);
	       
	     }    		
	
	  close(sock);
	  bzero(request,1024);
          bzero(buffer,1024);
	  }
	
        }
	if(VERBOSE){
	  fprintf(stdout,"[END of FILEs Search in %s ]\n",path);
	}
	close(sock);
	fclose(ffile);
	return 0; 

}

/*http put scan*/
int
put_scanner(struct hostent *he,char *host,int puerto,char *path,char *filename){

	char buffer[1024],
	     request[1024],
	     recbuffer[512];
	     
	char *cleannl;     
	
	int sock;
	struct in_addr addr; 
	struct sockaddr_in sin;
	
	
	
	char filefound1[] = " 201 ";  /*PUT Created Code*/
	
	
	if(VERBOSE==1){
	  fprintf(stdout,"\n[Searching for HTTP PUT on http://%s:%d%s ]\n",host,puerto,path);
	}   
	bzero(buffer,1024);
	bzero(request,1024);
	if(VERBOSE==1){
	   fprintf(stdout,"-[Testing... ]\n");
	}
	     //fprintf(stdout,"[Connecting...]\n");
	     
	     
  	     sock=socket(AF_INET,SOCK_STREAM,0);
  	     bcopy(he->h_addr, (char *)&sin.sin_addr,he->h_length);
  	     sin.sin_family=AF_INET; 
  	     sin.sin_port=htons(puerto);
  	     if (connect(sock,(struct sockaddr*)&sin,sizeof(sin))!=0){  
      		 perror("[Error: connect]\n");
		 exit(0);  
  	     }
  	     if(SHOW==1){
	       fprintf(stdout,"-[PUT %s ]\n",path);
	     }
	     strcpy(request,"PUT ");
	     strcat(request,path);
	     strcat(request,filename);
	     strcat(request," HTTP/1.0\n");
	     strcat(request,"User-Agent: wmap v0.1\n");
	     strcat(request,"Host: ");
	     strcat(request,host);
	     strcat(request,"\n");
	     strcat(request,"Content-Length: 5\n\nwmap!\n\n");
	     
	     
	     //fprintf(stdout,"%s",request); /*for debug purpose*/
	     
	     send (sock, request, strlen(request),0);
	     
	     bzero(recbuffer,512);
	     recv(sock, recbuffer,sizeof(recbuffer),0);
             //fprintf(stdout,"rcv: %s\n",recbuffer); /*for debug purpose*/ 

             if(strstr(recbuffer,filefound1)!=NULL){ 
	       fprintf(stdout,"--[ HTTP PUT Found!!!: %s ]\n",path);
	       fprintf(stdout,"---[ File created: %s ]\n",filename);
	       exit(0);
	     }
                 		
	
	
	if(VERBOSE==1){
	  fprintf(stdout,"[END of HTTP PUT Search in %s ]\n",path);
	}
	close(sock);
	return 0; 

}

/*dir browseable*/
int
browseable(struct hostent *he,char *host,int puerto,char *path){
        
	char request[1024],
	     recbuffer[512];
	     
	char *cleannl;     
	
	int sock;
	struct in_addr addr; 
	struct sockaddr_in sin;
	
	
	
	
	
	   
	bzero(request,1024);
	
	     
  	     sock=socket(AF_INET,SOCK_STREAM,0);
  	     bcopy(he->h_addr, (char *)&sin.sin_addr,he->h_length);
  	     sin.sin_family=AF_INET; 
  	     sin.sin_port=htons(puerto);
  	     if (connect(sock,(struct sockaddr*)&sin,sizeof(sin))!=0){  
      		 perror("[Error: connect]\n");
		 exit(0);  
  	     }
  	     
	     strcpy(request,"GET ");
	     
	     strcat(request,path);
	     strcat(request," HTTP/1.0");
	     strcat(request,"\nHost: ");
	     strcat(request,host);
	     strcat(request,"\n\n");
	     
	     send (sock, request, strlen(request),0);
	     
	     bzero(recbuffer,512);
	     recv(sock, recbuffer,sizeof(recbuffer),0);
             //fprintf(stdout,"rcv: %s\n",recbuffer); /*for debug purpose*/ 

               if(strstr(recbuffer,"Index of ")!=NULL){
	         fprintf(stdout,"--[ BROWSEABLE: %s ]\n",path);
	       }
	  close(sock);
	  bzero(request,1024);
          

}

/*THE END */
/*[LoWNOISE] ET 2002*/
/*X-mas version*/
